package com.mypro.manager;

import java.util.ArrayList;
import java.util.HashMap;

import org.xmlpull.v1.XmlPullParser;

import com.mypro.base.graphics.Bitmap;
import com.mypro.manager.ImageConfig.ActConfig;
import com.mypro.model.FishInfo;
import com.mypro.model.GamingInfo;
import com.mypro.model.fish.Fish;
import com.mypro.tools.LogTools;

/**
 * Ĺ
 * @author Leslie Leung
 *
 */
public class FishManager {
	/**
	 * ģʽ
	 */
	private static FishManager fishManager;
	
	private FishManager(){
	}
	
	public static FishManager getFishMananger(){
		if(fishManager==null){
			fishManager = new FishManager();
		}
		return fishManager;
	}
	/**
	 * ֱϢ
	 */
	private HashMap<String,FishInfo> allFishConfig = new HashMap<String,FishInfo>();
	/**
	 * ֱĶϢ
	 */
	private HashMap<String,ActConfig[]> allFishActConfigs = new HashMap<String,ActConfig[]>();
	/**
	 * ֱĲϢ
	 */
	private HashMap<String,ActConfig[]> allFishCatchActConfigs = new HashMap<String,ActConfig[]>();
	/**
	 * ֻĶͼƬ
	 */
	private HashMap<String,Bitmap[]> allFishActs = new HashMap<String,Bitmap[]>();
	/**
	 * ֻĲͼƬ
	 */
	private HashMap<String,Bitmap[]> allFishCatchActs = new HashMap<String,Bitmap[]>();
	/**
	 * 
	 */
	private ArrayList<String> allFish = new ArrayList<String>();
	/**
	 * XMLļʼ
	 * ļû壬ֻдڴˣԺԸĳͨȡļزͬ
	 * Դ
	 * @param initXml
	 */
	
	/**
	 * ǷԴµ
	 * ֵĸı»ᷢ:
	 * ÿupdateFishʱὫֵΪfalse
	 * updateFishִʱὫֵڸıtrue
	 */
	private boolean createable = false;
	/**
	 * ʼ
	 * ȡfishļµFishConfig.plistļϢ
	 */
	public void initFish(){
		try{			
			HashMap<String,ActConfig> configs = new HashMap<String,ActConfig>();
			//һ㶯ļ
			String fishActConfiges[]; 
			//ĻϢļ
			String fishInfoConfig;
			//عļ
			XmlPullParser xml = XmlManager.getXmlParser("fish/FishConfig", "UTF-8");
			//ȡfishActConfigϢ
			XmlManager.gotoTagByTagName(xml, "string");
			fishActConfiges = XmlManager.getValueByCurrentTag(xml).split(";");
			//ȡfishInfoConfigϢ
			XmlManager.gotoTagByTagName(xml, "string");		
			fishInfoConfig = XmlManager.getValueByCurrentTag(xml);
			//Xmlͷſռ
			xml = null;
			//ʼĶϢ
			this.initFishAct(configs, fishActConfiges);
			//ʼĻϢ
			this.initFishInfo(fishInfoConfig);
			
			int fishIndex = 1;
			StringBuffer fishName = new StringBuffer("fish01");
			while(getFishByName(fishName.toString(),configs)){
				fishName.delete(0, fishName.length());
				fishIndex++;
				if(fishIndex<10){
					fishName.append("fish0"+fishIndex);
				}else{
					fishName.append("fish"+fishIndex);
				}
			}
			configs = null;
			fishName = null;
			System.gc();
		}catch(Exception e){
			e.printStackTrace();
			LogTools.doLogForException(e);
		}
	}
	/**
	 * ֻȡһʵ
	 * @param fishName
	 * @return
	 */
	public Fish birthFishByFishName(String fishName){
		if(createable){
			Fish fish = new Fish(getFishActByFishName(fishName),getFishCatchActsByFishName(fishName),allFishConfig.get(fishName));
			/**
			 * ӦûҪһöFishConfig
			 */
			return fish;
		}else{
			System.out.println("FishManager:ܴ㣬ǷùupdateFish?");
			return null;
		}
		
	}	
	/**
	 * ¼ص
	 * @param fish
	 */
	public void updateFish(String []fish){
		this.createable = false;
		HashMap<String,Bitmap[]> fishAct = new HashMap<String,Bitmap[]>();
		HashMap<String,Bitmap[]> fishCatchAct = new HashMap<String,Bitmap[]>();
		for(String fishName:fish){
			fishAct.put(fishName, getFishActByFishName(fishName));
			fishCatchAct.put(fishName, getFishCatchActsByFishName(fishName));
		}
		allFishActs = fishAct;
		allFishCatchActs = fishCatchAct;
		this.createable = true;
		//еԺһ»
		ImageManager.getImageMnagaer().clearImageCache();
	}
	/**
	 * ȡ
	 * @return
	 */
	public ArrayList<String> getAllFishName(){
		return allFish;
	}
	/**
	 * ͷԴ
	 */
	public static void destroy(){
		fishManager = null;
		System.gc();
	}
	
	/**
	 * Ķ㶯ṹ
	 * @param fishName
	 * @param fishActs
	 * @return true:óɹ false:ʧ
	 */
	private boolean getFishByName(String fishName,HashMap<String,ActConfig> configs){
		//ͼȫ(fish12_01.png)
		StringBuffer fishFullName = new StringBuffer();
		//ıͼȫ(fish12_catch_01.png)
		StringBuffer fishCatchFullName = new StringBuffer();
		//ǰֵƴļ
		int fishNum = 1;
		//ʱŵǰͼƬļ
		ArrayList<ActConfig> allActs = new ArrayList<ActConfig>();
		//ʱŵǰбͼƬļ
		ArrayList<ActConfig> allCatchActs = new ArrayList<ActConfig>();
		//ȡǰж
		while(GamingInfo.getGamingInfo().isGaming()){
			fishFullName.delete(0, fishFullName.length());
			//һ֡ͼƬ
			ActConfig fishAct = null;
			if(fishNum<10){
				fishFullName.append(fishName+"_0"+fishNum+".png");
			}else{
				fishFullName.append(fishName+"_"+fishNum+".png");
			}
			fishNum++;
			if((fishAct = configs.get(fishFullName.toString()))!=null){
				allActs.add(fishAct);
			}else{
				break;
			}
		}
		fishFullName = null;
		System.gc();
		fishNum = 1;
		//ȡǰб
		while(GamingInfo.getGamingInfo().isGaming()){
			fishCatchFullName.delete(0, fishCatchFullName.length());
			//һ֡ͼƬ
			ActConfig fishCatchAct = null;
			if(fishNum<10){
				fishCatchFullName.append(fishName+"_catch_0"+fishNum+".png");
			}else{
				fishCatchFullName.append(fishName+"_catch_"+fishNum+".png");
			}
			fishNum++;
			if((fishCatchAct = configs.get(fishCatchFullName.toString()))!=null){
				allCatchActs.add(fishCatchAct);
			}else{
				break;
			}
		}
		fishCatchFullName = null;
		System.gc();
		//ûнĶ
		if(allActs.size()==0){
			//nullʾû
			return false;
		}else{
			//ݵǰַӦж
			ActConfig[] fishActArray = new ActConfig[allActs.size()];
			ActConfig[] fishCatchActsArray = new ActConfig[allCatchActs.size()];
			for(int i =0;i<allActs.size();i++){
				fishActArray[i] = allActs.get(i);
			}
			for(int i =0;i<allCatchActs.size();i++){
				fishCatchActsArray[i] = allCatchActs.get(i);
			}
			allActs = null;
			allCatchActs = null;		
			allFishActConfigs.put(fishName,fishActArray);
			allFishCatchActConfigs.put(fishName,fishCatchActsArray);
			allFish.add(fishName);
			System.gc();
			return true;
		}
	}
	
	/**
	 * ȡζͼƬ
	 * @param fishName
	 * @return
	 */
	private Bitmap[] getFishActByFishName(String fishName){
		if(allFishActs.get(fishName)==null){
			Bitmap []acts = ImageManager.getImageMnagaer().getImagesByActConfigs(allFishActConfigs.get(fishName),ImageManager.getImageMnagaer().fishScaleNum);
			//еͼת180ȣΪǻͷҵ
			for(int i =0;i<acts.length;i++){
				acts[i] = ImageManager.getImageMnagaer().rotateImage(180, acts[i]);
			}
			return acts;
			
		}else{			
			return allFishActs.get(fishName);
		}

	}
	/**
	 * ȡıͼƬ
	 * @param fishName
	 * @return
	 */
	private Bitmap[] getFishCatchActsByFishName(String fishName){
		if(allFishCatchActs.get(fishName)==null){
			Bitmap []acts = ImageManager.getImageMnagaer().getImagesByActConfigs(allFishCatchActConfigs.get(fishName),ImageManager.getImageMnagaer().fishScaleNum);
			//еͼת180ȣΪǻͷҵ
			for(int i =0;i<acts.length;i++){
				acts[i] = ImageManager.getImageMnagaer().rotateImage(180, acts[i]);
			}
			return acts;
		}else{
			return allFishCatchActs.get(fishName);
		}
		
	}
	/**
	 * ʼϢ
	 * @param config
	 */
	private void initFishInfo(String config){
		try{
			//Ϣûҵ׳쳣
			if(config==null){
				throw new Exception("FishManager:ȡļûҵfishInfoConfigϢ");
			}
			//ĻϢļ
			XmlPullParser xml = XmlManager.getXmlParser(config, "UTF-8");
			//еĻϢ
			while(GamingInfo.getGamingInfo().isGaming()&&XmlManager.gotoTagByTagName(xml, "key")){
				XmlManager.gotoTagByTagName(xml, "string");
				String fishName = XmlManager.getValueByCurrentTag(xml);
				FishInfo fishInfo = new FishInfo();
				//תǶ
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setMaxRotate(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				//ƶٶ
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setFishRunSpeed(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				//öٶ
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setActSpeed(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				//Ⱥ
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setFishShoalMax(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				//ͼID
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setFishInLayer(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				//ļֵ
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setWorth(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				//Ĳ׽
				XmlManager.gotoTagByTagName(xml, "integer");
				fishInfo.setCatchProbability(Integer.parseInt(XmlManager.getValueByCurrentTag(xml)));
				allFishConfig.put(fishName, fishInfo);
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	/**
	 * ʼĶϢ
	 * @param configs			ÿļMap
	 * @param fishActConfiges	еļ
	 */
	private void initFishAct(HashMap<String,ActConfig> configs,String fishActConfiges[]){
		try{
			//Ϣûҵ׳쳣
			if(fishActConfiges==null){
				throw new Exception("FishManager:ȡļûҵfishActConfigϢ");
			}
			for(String actConfig : fishActConfiges){
				configs.putAll(ImageManager.getImageMnagaer().createImageConfigByPlist(actConfig).getAllActs());
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
}
