package com.mypro.manager;

import com.mypro.base.graphics.Matrix;
import com.mypro.base.tools.Log;
import com.mypro.constant.Constant;
import com.mypro.model.GamingInfo;
import com.mypro.model.fish.Fish;
import com.mypro.threads.FishRunThread;
import com.mypro.threads.PicActThread;
import com.mypro.tools.LogTools;

/**
 * Ⱥ
 * @author Leslie Leung
 *
 */
public class ShoalManager{
	private String[] fish;							//ɵȺ
	private int[] showProbability;					//ɸ
	private boolean createable;						//ǷȺ

	public ShoalManager(){
	}
	/**
	 * Ⱥ
	 * @param gamePartInfo
	 */
	public void start(final GamePartInfo gamePartInfo){
		this.fish = gamePartInfo.getFishName();							//ÿԴȺ
		this.showProbability = gamePartInfo.getShowProbability();
		createable = true;												//ÿԴȺ
		new Thread(new Runnable(){
			public void run(){
				for(int i = 0;i<gamePartInfo.getShoalSumInScreen()&&GamingInfo.getGamingInfo().isGaming();i++){
					createShoal();
					try {
						Thread.sleep((long)(Math.random()*100*gamePartInfo.getShoalSumInScreen()));
					} catch (Exception e) {
						LogTools.doLogForException(e);
					}
				}
			}
		}).start();	
	}
	/**
	 * һȺ
	 */
	public void createShoal(){
		try {
			if(!createable){
				Log.w("ShoalManager", "Ⱥ");
				return;
			}
			HeadFish fish = birthHeadFish();
			createShoal(fish);
			fishRun(fish);
			startFishAct(fish.getFish());
			setRandomShoalPositionByHeadFish(fish);
		} catch (Exception e) {
			LogTools.doLogForException(e);
		}
		
	}
	
	
	
	/**
	 * һͷ
	 */
	private HeadFish birthHeadFish(){
		//һͷ
		HeadFish headFish = new HeadFish();
		Fish fish = null;
		int probability = (int)(Math.random()*100+1);		//1~100
		int sumProbability = 0;
		if(probability<=showProbability[0]){
			fish = FishManager.getFishMananger().birthFishByFishName(this.fish[0]);
		}else{
			sumProbability = showProbability[0];
			for(int index=1;index<this.showProbability.length;index++){
				sumProbability += this.showProbability[index];
				if(probability<=sumProbability){
					fish = FishManager.getFishMananger().birthFishByFishName(this.fish[index]);
					break;
				}
			}
		}		 

		fish.setCanRun(true);
		GamingInfo.getGamingInfo().getFish().add(fish);
		headFish.setFish(fish);
		fish.setHeadFish(headFish);
		//һͷ󣬽õcurrentFromPointϣȺʹ
		headFish.setCurrentFromPoint(getFromPoint(headFish));		
		
		return headFish;
	}
	/**
	 * 㿪ʼζ
	 * @param fish			Ҫζ
	 */
	private void fishRun(HeadFish fish){
		FishRunThread prt = new FishRunThread(fish);	// ǰƶ߳	
		fish.setFishRunThread(prt);
		prt.setRun(true);	//㿪ʼƶ	
		prt.start();
	}
	/**
	 * ʼĶ
	 * @param fish			Ҫζ
	 */
	private void startFishAct(Fish fish){
		//Ⱥͼ
		GamingInfo.getGamingInfo().getSurface().putDrawablePic(fish.getFishInfo().getFishInLayer(), fish);
		PicActThread pat = new PicActThread(fish); 				// ǰĶ߳		
		fish.setPicActThread(pat);
		pat.start();// Ķ߳
	}
	/**
	 * Ⱥ 
	 * @param fish	ͷ
	 */
	private void createShoal(HeadFish fish){
		try{
			if(GamingInfo.getGamingInfo().isGaming()&&fish.getFish().getFishInfo().getFishShoalMax()!=0){
				Fish flagFish;					//Ⱥеʱ
				int sum = (int)(Math.random()*fish.getFish().getFishInfo().getFishShoalMax()+1);
				for(int i = 0;i<sum;i++){
					flagFish = fish.getFish().getFish();
					flagFish.setHeadFish(fish);
					fish.getShoal().add(flagFish);
					GamingInfo.getGamingInfo().getFish().add(flagFish);
				}	
			}	
		}catch(Exception e){
			LogTools.doLogForException(e);
		}
	}
	/**
	 * ͷλλ,λõƫֵȺ
	 * @param headFish			ͷ
	 */
	private void setRandomShoalPositionByHeadFish(final HeadFish headFish){
		try{
		new Thread(new Runnable(){			
			public void run() {
				try{
				float fromY = headFish.getFish_Y();
				int shoalIndex = 1;
				int sumAtOut = headFish.getShoal().size();//ȺлжĻ
				Fish fishFlag;			
				float randomMinY;
				float randomMaxY;
				float flagFishX,flagFishY;//ɵ
				Fish startFish = headFish.getFish();
				
				// TODO Auto-generated method stub
				while(GamingInfo.getGamingInfo().isGaming()){
					while(!GamingInfo.getGamingInfo().isPause()&&sumAtOut>1){
						fishFlag = headFish.getShoal().get(shoalIndex);
						
						randomMinY = (float)(fromY-fishFlag.getPicHeight());
						randomMaxY = (float)(fromY+fishFlag.getPicHeight());
						
						if(headFish.getCurrentFromPoint()<=Constant.FROM_BOTTOM_LEFT){						
							flagFishX = 0-headFish.getFish().getPicWidth();
							flagFishY = (float)(randomMinY+Math.random()*(randomMaxY-randomMinY));
							
						}else{
							flagFishX = GamingInfo.getGamingInfo().getScreenWidth();
							flagFishY = (float)(randomMinY+Math.random()*(randomMaxY-randomMinY));						
							
						}
						
						while(!canRun(startFish,flagFishX,flagFishY,headFish)&&GamingInfo.getGamingInfo().isGaming()){
							try{
								Thread.sleep(50);
							}catch(Exception e){
								
							}
						}
						
						fishFlag.setDistanceHeadFishX(headFish.getFish_X()-flagFishX);
						fishFlag.setDistanceHeadFishY(headFish.getFish_Y()-flagFishY);
						fishFlag.setCanRun(true);
						startFishAct(fishFlag);
						startFish = fishFlag;					
						shoalIndex++;
						sumAtOut--;		
						try{
							Thread.sleep(200);
						}catch(Exception e){
							
						}
					}
					break;
				}
			}catch(Exception e){}}}).start();
		}catch(Exception e){}
	}
	/**
	 * жǷƶ
	 * Ǹݲλã׼ƶǷƶ
	 * @param firstFish		
	 * @param fishFlag		׼ƶ
	 * @param headFish		ͷ
	 * @return
	 */
	private boolean canRun(Fish firstFish,float fishX,float fishY,HeadFish headFish){
		//ʼĻ
		if(headFish.getCurrentFromPoint()<=Constant.FROM_BOTTOM_LEFT){						
			if(fishY+firstFish.getPicHeight()<headFish.getFish_Y()-firstFish.getDistanceHeadFishY()
					||fishY>headFish.getFish_Y()-firstFish.getDistanceHeadFishY()+firstFish.getPicHeight()
					||headFish.getFish_X()-firstFish.getDistanceHeadFishX()>0){
				return true;
			}
		}else{				
			if(fishY+firstFish.getPicHeight()<headFish.getFish_Y()-firstFish.getDistanceHeadFishY()
					||fishY>headFish.getFish_Y()-firstFish.getDistanceHeadFishY()+firstFish.getPicHeight()
					||headFish.getFish_X()-firstFish.getDistanceHeadFishX()+firstFish.getPicWidth()<GamingInfo.getGamingInfo().getScreenWidth()){
				return true;
			}
		}
		return false;
	}
	
	/**
	 * ֪ͨȺͷѾ뿪Ļ
	 */
	public void notifyFishIsOutOfScreen(){
		try{			
			createShoal();	
		}catch(Exception e){
			LogTools.doLogForException(e);
		}
	}
	
	/**
	 * ʼ Ļֳĸλ
	 */
	private int getFromPoint(HeadFish fish) {
		int mode = (int) (Math.random() * 4);
		Matrix matrix = fish.getFish().getPicMatrix();
		switch (mode) {
		case Constant.FROM_TOP_LEFT:
			// 
			fish.setFish_X(-(float) fish.getFish().getPicWidth());
			fish.setFish_Y((float) Math.random()
					* (GamingInfo.getGamingInfo().getScreenHeight() / 2 - fish.getFish().getPicHeight() + 1));
			matrix.setTranslate(fish.getFish_X(), fish.getFish_Y());		
			fish.setLastX(1);			
			return Constant.FROM_TOP_LEFT;
		case Constant.FROM_BOTTOM_LEFT:
			// 
			fish.setFish_X(-(float) fish.getFish().getPicWidth());
			fish.setFish_Y((float) (GamingInfo.getGamingInfo().getScreenHeight() / 2 + Math.random()
					* (GamingInfo.getGamingInfo().getScreenHeight() - fish.getFish().getPicHeight() + 1 - GamingInfo.getGamingInfo().getScreenHeight() / 2)));
			matrix.setTranslate(fish.getFish_X(), fish.getFish_Y());
			fish.setLastX(1);
			return Constant.FROM_BOTTOM_LEFT;
		case Constant.FROM_TOP_RIGHT:
			// 
			fish.setFish_X((float) GamingInfo.getGamingInfo().getScreenWidth());
			fish.setFish_Y((float) Math.random()
					* (GamingInfo.getGamingInfo().getScreenHeight() / 2 - fish.getFish().getPicHeight() + 1));
			matrix.setTranslate(fish.getFish_X(), fish.getFish_Y());
			matrix.preRotate(180, fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y());
			fish.setCurrentRotate(180);
			fish.setLastX(-1);
			return Constant.FROM_TOP_RIGHT;
		case Constant.FROM_BOTTOM_RIGHT:
			// 
			fish.setFish_X((float) GamingInfo.getGamingInfo().getScreenWidth());
			fish.setFish_Y((float) (GamingInfo.getGamingInfo().getScreenHeight() / 2 + Math.random()
					* (GamingInfo.getGamingInfo().getScreenHeight() - fish.getFish().getPicHeight() + 1 - GamingInfo.getGamingInfo().getScreenHeight() / 2)));			
			matrix.setTranslate(fish.getFish_X(), fish.getFish_Y());
			matrix.preRotate(180, fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y());
			fish.setCurrentRotate(180);
			fish.setLastX(-1);
			return Constant.FROM_BOTTOM_RIGHT;
		}
		return 0;
	}
	
	
	/**
	 * Ⱥ
	 * @param fish
	 */
	public void stop(){
		this.createable = false;
	}
	
}
