package com.mypro.threads;

import java.util.ArrayList;

import com.mypro.base.graphics.Matrix;
import com.mypro.constant.Constant;
import com.mypro.manager.CatchFishManager;
//import com.mypro.manager.ParticleEffectManager;
import com.mypro.model.Ammo;
import com.mypro.model.GamingInfo;
import com.mypro.model.fish.Fish;
import com.mypro.tools.LogTools;
import com.mypro.tools.Tool;

public class ShotThread extends Thread {
	private float targetX;
	private float targetY;
	private float currentX;
	private float currentY;
	private float ammoRotateX;
	private float ammoRotateY;
	private float speed_x; 														// ȡһֵÿ֡ƶ
	private float speed_y;
	private int ammo_speed = 1000 / Constant.ON_DRAW_SLEEP; 					// ӵٶ,Ļˢٶһ
	private Ammo ammo;															//ӵ
	private boolean ammoActIsRun;												//ӵǷ񲥷

	public ShotThread(float targetX, float targetY, Ammo ammo,float fromX,float fromY) {
		this.ammo = ammo;
		currentX = fromX;
		currentY = fromY;
		ammoRotateX = ammo.getPicWidth()/2;
		ammoRotateY = ammo.getPicHeight()/2;
		this.targetX = targetX;
		this.targetY = targetY;
		float x = Math.abs(this.targetX - fromX); 				// ȡĿӵʼX곤
		float y = Math.abs(this.targetY - fromY); 				// ȡĿӵʼY곤
		float len = (float) Math.sqrt(x * x + y * y); 							// Ŀʼ֮ľ
		float time = len / (Constant.AMMO_SPEED / Constant.ON_DRAW_SLEEP); 		// Ŀʼ֮ӵҪߵ֡
		speed_x = x / time; 													// ӵXн
		speed_y = y / time; 													// ӵYн
		if (targetX < fromX) {
			speed_x = -speed_x;
		}
		if (targetY < fromY) {
			speed_y = -speed_y;
		}
	}

	public void run() {
		try{
			//ӵ֡1Ͳӵ
			if(ammo.getAmmoPicLenght()>1){
				new Thread(this.playAmmoAct()).start();
			}
			// ӵҪתǶ
			float angle = Tool.getAngle(targetX, targetY, currentX, currentY);

			int ammoRedius = ammo.getPicHeight()/2;//뾶ڼӵβʹʹ
//			effect.playEffect((float)(ammoRedius*Math.cos(Math.toRadians(angle+180)))+ammoRotateX,-(float)(ammoRedius*Math.sin(Math.toRadians(angle+180)))+ammoRotateY,currentX, currentY, speed_x, speed_y);
			// ӵתԭһ
			if (angle >= 90) {
				angle = -(angle - 90);
			} else {
				angle = 90 - angle;
			}
			// 任
			Matrix matrix = ammo.getPicMatrix();
			matrix.setTranslate(currentX, currentY);
			matrix.preRotate(angle,ammoRotateX,ammoRotateY);
			GamingInfo.getGamingInfo().getSurface()
			.putDrawablePic(Constant.AMMO_LAYER, ammo); 				// ӵͼ㣬ȴ
			// ƶӵ
			while (GamingInfo.getGamingInfo().isGaming()) {
				while(!GamingInfo.getGamingInfo().isPause()){
					matrix.reset();
					matrix.setTranslate(currentX, currentY);
					matrix.preRotate(angle,ammoRotateX,ammoRotateY);
					currentX += speed_x;
					currentY += speed_y;
//					effect.setEffectMatrix(currentX,currentY);
					if (checkHit()) {
//						effect.stopEffect();
						// кɾӵ
						GamingInfo.getGamingInfo().getSurface()
								.removeDrawablePic(Constant.AMMO_LAYER, ammo);
						CatchFishManager.getCatchFishManager().catchFishByAmmo(currentX, currentY, ammo);
						// Ļͼɾӵ
						GamingInfo.getGamingInfo().getSurface()
								.removeDrawablePic(Constant.AMMO_LAYER, ammo);
						this.ammoActIsRun = false;//ֹͣӵ
						break;
					} else if (currentX - 100 >= GamingInfo.getGamingInfo().getScreenWidth()
							|| currentX + 100 <= 0 || currentY + 100 <= 0) {
						// Ļͼɾӵ
//						effect.stopEffect();
						GamingInfo.getGamingInfo().getSurface()
								.removeDrawablePic(Constant.AMMO_LAYER, ammo);
						this.ammoActIsRun = false;//ֹͣӵ
						break;
					}
					try {
						Thread.sleep(ammo_speed);
					} catch (Exception e) {
		
					}
				}
				break;
			}
		}catch(Exception e){
			LogTools.doLogForException(e);
		}
	}

	private Runnable playAmmoAct(){
		Runnable runnable = new Runnable(){			
			@Override
			public void run() {
				ammoActIsRun = true;
				int picIndex = 0;
				try {
					while(GamingInfo.getGamingInfo().isGaming()){
						while(!GamingInfo.getGamingInfo().isPause()&&ammoActIsRun){
							ammo.setCurrentId(picIndex);
							picIndex++;
							if(picIndex==ammo.getAmmoPicLenght()){
								picIndex=0;
							}
							Thread.sleep(200);
						}
						break;
					}
				} catch (Exception e) {
					// TODO: handle exception
				}
			}
			
		};
		return runnable;
	}
	
	private boolean checkHit() {
		try{
			ArrayList<Fish> allFish = (ArrayList<Fish>)GamingInfo.getGamingInfo().getFish().clone();
			for (Fish fish : allFish) {
				if (currentX > fish.getFishOutlinePoint()[0]
						&& currentX < fish.getFishOutlinePoint()[1]
						&& currentY > fish.getFishOutlinePoint()[2]
						&& currentY < fish.getFishOutlinePoint()[3]) {
					return true;
				}
			}
		}catch(Exception e){
			LogTools.doLogForException(e);
		}
		return false;
	}
}
