package mines;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.*;
import javax.swing.*;

/**
 * ɨ׳
 * @author Leslie Leung
 */
public class MinesFields extends JPanel {
	public static final int ROWS = 16;	//
	public static final int COLUMNS = 16;	//
	public static final int MINES_NUM = 40;		//׵Ŀ
	
	private Map<String, Field> fields;		//ʾField
	private List<Field> notMineFields;		//ʾвǵ׵Fieldļ
	private GameRunScript mouseListener;	//ʾ¼ļ
	
	/**
	 * MinesFields๹췽
	 */
	public MinesFields() {
		setPreferredSize(new Dimension(ROWS * Field.FIELD_SIZE, COLUMNS * Field.FIELD_SIZE));	//ɨС
		
		fields = new HashMap<String, Field>();	//ùϣʾеField
		notMineFields = new ArrayList<Field>();
		mouseListener = new GameRunScript();
		Random random = new Random();
		
		int mineX, mineY;	//¼ɵ׵
		List<Field> aroundList;		//ʾȡĸFieldĸFieldļ
		
		/* еÿField */
		for(int x = 0; x < COLUMNS; x ++) {
			for(int y = 0; y < ROWS; y ++) {
				fields.put(x + "," + y, new Field(x, y));	//Field󣬲Ѷӵfields
			}
		}
		
		/* 40ײø */
		for(int i = 0; i < MINES_NUM; i ++) {
			/* ɵĵظõ׵ */
			do {
				mineX = random.nextInt(COLUMNS);
				mineY = random.nextInt(ROWS);
			} while(isMine(mineX, mineY));
			
			setMine(mineX, mineY);	//ӦļֵѸFieldΪ
			aroundList = getAround(mineX, mineY);		//ȡõ׸Field
			
			/* aroundListѲǵ׵Fieldĵֵ1 */
			for(Field field: aroundList) {
				if(!field.isMine()) {
					field.setMineValue(field.getMineValue() + 1);
				}
			}
			
		}
		
		/* Ѳǵ׵FieldӵnotMineFields */
		for(int x = 0; x < COLUMNS; x ++) {
			for(int y = 0; y < ROWS; y ++) {
				if(!getField(x, y).isMine()) {
					notMineFields.add(getField(x, y));
				}
			}
		}
	}
	
	/**
	 * ȡڲʵ
	 * @return ڲʵ
	 */
	public GameRunScript getInnerInstance() {
		return mouseListener;
	}
	
	/**
	 * ڲ࣬ʵϷϲĹ
	 * @author Leslie Leung
	 */
	 private class GameRunScript extends MouseAdapter {
		@Override
		public void mousePressed(MouseEvent e) {
			Point p = e.getPoint();		//ȡλõǸ
			int y = p.x / Field.FIELD_SIZE;		//ȡĵĺ
			int x = p.y / Field.FIELD_SIZE;		//ȡĵ

			/*  */
			if(e.getButton() == MouseEvent.BUTTON1) {
				open(x, y);
			} 
			/* ˫ */
			if(e.getClickCount() == 2) {
				openAround(x, y);
			}
			/* Ҽ,Ǹȡı */
			if(e.getButton() == MouseEvent.BUTTON3) {
				mark(x, y);
			}
				
		} 
	}
	
	/**
	 * вǵ׵FieldжǷȫѴ
	 * @return trueȫѴ򿪣falseֻȫû
	 */
	public boolean isAllOpened() {
		for(Field field: notMineFields) {
			if(!field.isOpened()) {
				return false;
			}
		}
		explode();
		return true;
	}
	 
	/**
	 * һField
	 * @param x 
	 * @param y 
	 * @return Field
	 */
	public Field getField(int x, int y) {
		return fields.get(x + "," + y);
	}
	
	/**
	 * زǵ׵Field
	 * @param x ĳFieldĺ
	 * @param y ĳField
	 * @return ǵ׵Fieldڼ
	 */
	public List<Field> getAround(int x, int y) { 
		List<Field> aroundList = new ArrayList<Field>();
		
		for(int m = -1; m <= 1; m ++) {
			for(int n = -1; n <= 1; n ++) {
				/* ѡеĶΪױѭ */
				if(m == 0 && n == 0) {
					continue;
				}
				
				/* жǷȡĵ׵ǷԽ磬񣬰Ѳǵ׵FieldŽaroundList */
				if(x + m < COLUMNS && x + m >= 0 && y + n >= 0 && y + n < ROWS) {
					aroundList.add(getField(x + m, y + n));
				}
				
			}
		}
		
		return aroundList;
		
	}
	
	/**
	 * FieldĵֵΪ0ʱݹ丽Field
	 * @param x 
	 * @param y 
	 */
	public void open(int x, int y) {
		if(isCovered(x, y)) {
			/* ǸFieldǵ׵ĻȫField */
			if(isMine(x, y)) {
				explode();
				JOptionPane.showMessageDialog(null, "");
				return;
			}			
			setOpened(x, y);	//ѸFieldΪ״̬
			repaint();
			
			if(isAllOpened()) {//ȫѱ
				JOptionPane.showMessageDialog(null, "ϲ㣬Ӯˣ");
			}	
			
			/* fieldĵֵΪ0Ŵ򿪸Field */
			if(getMineValue(x, y) == 0) {
				List<Field> aroundList = getAround(x, y);
				
				/* ݹôĳFieldField */
				for(Field field: aroundList) {
					open(field.getX(), field.getY());
				}
			}
			
		}
	}
	
	/**
	 * ڸFieldǺڴ򿪸Fieldķ
	 * @param x 
	 * @param y 
	 */
	public void openAround(int x, int y) {
		if(isOpened(x, y) && getMineValue(x, y) > 0) {//FieldѴ򿪲ĵֵ0
			
			List<Field> aroundList = getAround(x, y);
			int mineNum = 0;
			
			for(Field field: aroundList) {
				/* FieldѱǣmineNum1 */
				if(field.isMarked()) {
					mineNum ++;
				}
			}
			
			/* FieldĵֵmineNumʱִĲ  */
			if(getMineValue(x, y) == mineNum) {
				for(Field field: aroundList) {	
					if(field.isMarked() && !field.isMine()) {
						explode();	//FieldҸFieldǵףϴField
						JOptionPane.showMessageDialog(null, "");
					} else if(!field.isMarked() && !field.isMine()) {
						open(field.getX(), field.getY());//fieldǵʱopen
					}
				}
				
			}
		}
		
	}
	
	/**
	 * ĳFieldΪ״̬
	 * @param x 
	 * @param y 
	 */
	public void setOpened(int x, int y) {
		getField(x, y).setStyle(Field.STYLE_OPENED);
	}
	
	/**
	 * ݱ״̬Ϊǻȡ
	 * @param x 
	 * @param y 
	 */
	public void mark(int x, int y) {
		if(isCovered(x, y)) {
			setMarked(x, y);
			repaint();
		} else if(isMarked(x, y)) {
			setCovered(x, y);
			repaint();
		}
	}
	
	/**
	 * ĳFieldΪ
	 * @param x 
	 * @param y 
	 */
	public void setMarked(int x, int y) {
		getField(x, y).setStyle(Field.STYLE_MARKED);
	}
	
	/**
	 * жһFieldǷ񱻱
	 * @param x 
	 * @param y 
	 * @return ǣtruefalse
	 */
	public boolean isMarked(int x, int y) {
		return getField(x, y).isMarked();
	}
	
	/**
	 * жĳFieldǷ
	 * @param x 
	 * @param y 
	 * @return trueǵףfalseǵ
	 */
	public boolean isMine(int x, int y) {
		return getField(x, y).isMine();
	}
		
	/**
	 * ͨmineValueֵΪ-100ʾFieldΪ
	 * @param x 
	 * @param y 
	 */
	public void setMine(int x, int y) {
		getField(x, y).setMine();
	}
	
	/**
	 * жϸFieldǷѴ
	 * @param x
	 * @param y
	 * @return trueѱ򿪣falseû
	 */
	public boolean isOpened(int x, int y) {
		return getField(x, y).isOpened();
	}
	
	/**
	 * ָFieldĵֵ
	 * @param x 
	 * @param y 
	 * @return Fieldĵֵ
	 */
	public int getMineValue(int x, int y) {
		return getField(x, y).getMineValue();
	}
	
	/**
	 * жĳFieldǷΪ
	 * @param x  
	 * @param y 
	 * @return Ϊǣtruefalse
	 */
	public boolean isCovered(int x, int y) {
		return getField(x, y).isCovered();
	}
	
	/**
	 * ѸFieldʽΪ
	 * @param x 
	 * @param y 
	 */
	public void setCovered(int x, int y) {
		getField(x, y).setStyle(Field.STYLE_COVERED);
	}
	
	/**
	 * ȫField
	 */
	public void explode() {
		for(int x = 0; x < COLUMNS; x ++) {
			for(int y = 0; y < ROWS; y ++) {
				setOpened(x, y);
			}
		}
		repaint();
	}
	
	@Override
	public void paint(Graphics g) {
		g.setColor(Color.BLACK);
		g.fillRect(0, 0, getBounds().width, getBounds().height);
		
		for(int x = 0; x < COLUMNS; x ++) {
			for(int y = 0; y < ROWS; y ++) {
				getField(x, y).paintField(g);
			}
		}
			
	}
	
}
