package traingame;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/**
 * Ϸ
 * @author Leslie Leung
 */
public class TrainGame extends JPanel {
	public static final int PLAYER_ME = 0;	//Լ
	public static final int PLAYER_COMPUTER = 1;	//ϵͳ
	public static final int DEFAULT_PLAYER = PLAYER_ME;		//ĬȷƸԼ
	public static final int CARD_NUM = 52;		//ֽƵĿ
	public static final int OWN_TIME = 10000;	//Լʱƿصʱ
	public static final int INTERVAL = 1000;	//ԼmeCountDownʱ
	/* ڴ洢ֻʽ */
	public static final int[] ARR_SUIT = {Card.SUIT_SPADE, Card.SUIT_HEART, Card.SUIT_DIAMOND, Card.SUIT_CLUB};
	/* ڴ洢ֵ */
	public static final int[] ARR_POINT = {Card.POINT_A, Card.POINT_2, Card.POINT_3, Card.POINT_4, Card.POINT_5,
		Card.POINT_6, Card.POINT_7, Card.POINT_8, Card.POINT_9, Card.POINT_10, Card.POINT_J, Card.POINT_Q, Card.POINT_K};

	/* 10̬ */
	private static int xCoordinateOfMyCard = 100;	//ԼֽƵĺ
	private static int yCoordinateOfMyCard = 500;	//ԼֽƵ
	private static int xCoordinateOfComputerCard = 100;		//ϵͳֽƵĺ
	private static int yCoordinateOfComputerCard = 50;		//ϵͳֽƵ
	private static int xCoordinateOfTrainCard = 100;	//ֽƵĺ
	private static int yCoordinateOfTrainCard = 300;	//ֽƵ
	private static int xCoordinateOfAllCards = 10;	//ֽбĺ
	private static int yCoordinateOfAllCards = 10;	//ֽб
	private static int offsetBetweenCards = 10;		//һֽ֮ľƫ
	private static int timeLeftForPlayerMe = 10;	//Լʣĳʱ

	private List<Card> cards;	//ʾ
	private List<Card> train;	//ʾ
	private Map<Integer, List<Card>> players;	//ʾҺӵеֽ
	private int turn;	//ʾֵƷĸ
	private Timer dealTimer;	//ԴƵļʱ
	private Timer playTimer;	//ԴϷ̵ļʱ
	private Timer meCountDown;		//ʵԼƵĵʱ
	private boolean oneCardSelected;	//ʾĳֽǷѡ
	private MouseControl mc;	//ʵصڲĶ

	/**
	 * 췽
	 */
	public TrainGame() {
		setPreferredSize(new Dimension(800, 650));		//ϷС

		/* ʼ */
		cards = new LinkedList<Card>();
		train = new LinkedList<Card>();
		players = new HashMap<Integer, List<Card>>();
		turn = DEFAULT_PLAYER;
		dealTimer = new Timer();
		playTimer = new Timer();
		oneCardSelected = false;	//ʾĳֽûѡ
		mc = new MouseControl();	//½ڲ


		/* ֽ */
		for(int i = 0; i < ARR_SUIT.length; i ++) {
			for(int j = 0; j < ARR_POINT.length; j ++) {
				cards.add(new Card(ARR_POINT[j], ARR_SUIT[i]));
			}
		}

		Collections.shuffle(cards);	//ϴ

		/* ֽƵĺ */
		for(int i = 0; i < cards.size(); i ++) {
			cards.get(i).setX(xCoordinateOfAllCards);
			cards.get(i).setY(yCoordinateOfAllCards);
			yCoordinateOfAllCards += offsetBetweenCards;
		}

		/* ½ */
		players.put(PLAYER_ME, Collections.synchronizedList(new LinkedList<Card>()));
		players.put(PLAYER_COMPUTER, Collections.synchronizedList(new LinkedList<Card>()));

		dealTimer.schedule(new DealExecution(), 30, 80);
	}

	/**
	 * ڲ࣬Լ¼
	 * @author Leslie Leung
	 */
	private class MouseControl extends MouseAdapter {
		@Override
		public void mousePressed(MouseEvent e) {
			int x = e.getX();
			int y = e.getY();

			if(e.getButton() == MouseEvent.BUTTON1) {//ֽʱĲ
				findTrainCardByXYAndSetSelected(x, y);	//ҵĿֽλòǷѡ
			}

			if(e.getClickCount() == 2) {//ƺ˫ֽʱĲ

				List<Card> playerCardsList = getPlayerCards(PLAYER_ME);		//ԼֽƼ
				Card targetCard = playerCardsList.get(0);	//ĿֽƣԼĵһֽ

				/* ˫Լһֽʱ */
				if(playerCardsList.size() > 1 && x > targetCard.getX() && x < targetCard.getX() + offsetBetweenCards &&
						y > targetCard.getY() && y < targetCard.getY() + Card.CARD_HEIGHT) {

					play(PLAYER_ME);	//Լʼ

					/* ԼһƣֹͣplayTimerʱȨתƸϵͳ½playerTimer */
					playTimer.cancel();
					turn = PLAYER_COMPUTER;
					playTimer = new Timer();
					playTimer.schedule(new PlayExecution(), 0, OWN_TIME);				
				} 
				/* ˫ԼһֽƵʱ */
				else if(playerCardsList.size() == 1 && x > targetCard.getX() && x < targetCard.getX() + Card.CARD_WIDTH &&
						y > targetCard.getY() && y < targetCard.getY() + Card.CARD_HEIGHT) {

					play(PLAYER_ME);	//Լʼ

					/* ԼһƣֹͣplayTimerʱȨתƸϵͳ½playerTimer */
					playTimer.cancel();
					turn = PLAYER_COMPUTER;
					playTimer = new Timer();
				}
			}

			repaint();
		}
	}

	/**
	 * ݺҵĿֽƵλòǷѡ
	 * @param x ĳĺ
	 * @param y ĳ
	 */
	public void findTrainCardByXYAndSetSelected(int x, int y) {
		for(int i = 0; i < train.size(); i ++) {
			/* ĿֽΪϳһֽһ */
			if(i < train.size() - 1 && x > getTrainCard(i).getX() && x < getTrainCard(i).getX() + offsetBetweenCards &&
					y > getTrainCard(i).getY() && y < getTrainCard(i).getY() + Card.CARD_HEIGHT) {

				setTrainCardSelected(i);
				break;
			} 
			/* ĿֽΪһֽ */
			else if(i == train.size() - 1 && x > getTrainCard(i).getX() && x < getTrainCard(i).getX() + Card.CARD_WIDTH &&
					y > getTrainCard(i).getY() && y < getTrainCard(i).getY() + Card.CARD_HEIGHT){

				setTrainCardSelected(i);
				break;
			}
		}

	}

	/**
	 * ݻĳֽǷѡѡ״̬
	 * @param i ĳֽƵ±
	 */
	public void setTrainCardSelected(int i) {
		if(!getTrainCard(i).isSelected() && !oneCardSelected) {
			getTrainCard(i).setSelected(true);
			oneCardSelected = true;
		} else if(getTrainCard(i).isSelected() && oneCardSelected) {
			getTrainCard(i).setSelected(false);
			oneCardSelected = false;
		}
	}

	/**
	 * ȡϵĳֽ
	 * @param i е±
	 * @return Ŀֽ
	 */
	public Card getTrainCard(int i) {
		return train.get(i);
	}

	/**
	 * ڲ࣬ʵϷв
	 * @author Leslie Leung
	 */
	private class PlayExecution extends TimerTask {	
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if(turn == PLAYER_ME) {//Լ

				meCountDown = new Timer();	//ʼmeCountDown			
				timeLeftForPlayerMe = 10;	//ÿֵԼʱ赹ʱ			
				addMouseListener(mc);		//¼
				
				meCountDown.schedule(new TimerTask() {
					@Override
					public void run() {
						// TODO Auto-generated method stub
						if(timeLeftForPlayerMe > 0 && timeLeftForPlayerMe <= 10) {
							repaint();
							timeLeftForPlayerMe --;	//ʱ

							if(timeLeftForPlayerMe == 0) {
								play(PLAYER_ME);	//ԼʣʱΪ0ʱԶ
								turn = PLAYER_COMPUTER;		//ѲȨתϵͳ							
							}

						}
					}
				}, 0, INTERVAL);

			} else if(turn == PLAYER_COMPUTER) {//ϵͳҳ

				meCountDown.cancel();
				removeMouseListener(mc);	//Ƴ

				autoFindTrainCardAndSetSelected();	//ԶҵϵͳҽҪƵͬƲѡ
				play(PLAYER_COMPUTER);	//ϵͳҿʼϷ
				repaint();
				
				/* ϵͳֽƴ0ŰѲȨתƸԼ */
				if(getPlayerCards(PLAYER_COMPUTER).size() > 0) {
					/* ϵͳһƣֹͣplayTimerʱȨתƸԼ½playTimer */
					playTimer.cancel();
					turn = PLAYER_ME;		//ѲȨתԼ
					playTimer = new Timer();
					playTimer.schedule(new PlayExecution(), 0, OWN_TIME);
				}
						
			}

		}
	}

	/**
	 * ڲ࣬ʵַƲ
	 * @author Leslie Leung
	 */
	private class DealExecution extends TimerTask {
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if(cards.size() == 0) {

				dealTimer.cancel();		//Ѿֹ꣬ʱϷʼ
				turn = PLAYER_ME;	//տʼʱԼ
				playTimer.schedule(new PlayExecution(), 0, OWN_TIME);	//Ϸʼ

			} else {
				startDealing();		//ʼ
			}
			repaint();
		}			
	}

	/**
	 * ԶҵһϵͳҽҪƵһֽƲΪѡ
	 */
	public void autoFindTrainCardAndSetSelected() {
		for(int i = 0; i < train.size(); i ++) {
			/* ĳһֽƵĵϵͳҽҪƵĵһѻϵΪѡ */
			if(getTrainCard(i).getPoint() == getPlayerCards(PLAYER_COMPUTER).get(0).getPoint()) {
				getTrainCard(i).setSelected(true);
			}
		}
	}

	/**
	 * ת÷㷨
	 */
	public void startDealing() {
		if(turn == PLAYER_ME) {//ֵԼ

			Card c = cards.remove(cards.size() - 1);//Ƴֽбеһ
			setXOfMyCards(c);   //ԼֽƵĺ
			setYOfMyCards(c);   //ԼֽƵ

			deal(turn, c);		//
			turn = PLAYER_COMPUTER;		//Ѵתϵͳ

		} else if(turn == PLAYER_COMPUTER) {//ֵϵͳ

			Card c = cards.remove(cards.size() - 1);//Ƴֽбеһ
			setXOfComputerCards(c);		//ϵͳֽƵĺ
			setYOfComputerCards(c);		//ϵͳֽƵ

			deal(turn, c);		//
			turn = PLAYER_ME;	//ѴתԼ
		}
	}

	/**
	 * ԼֽƵĺ
	 * @param card Լĳֽ
	 */
	public void setXOfMyCards(Card card) {
		card.setX(xCoordinateOfMyCard);	
		xCoordinateOfMyCard += offsetBetweenCards;
	}

	/**
	 * ԼֽƵ
	 * @param card Լĳֽ
	 */
	public void setYOfMyCards(Card card) {
		card.setY(yCoordinateOfMyCard);
	}

	/**
	 * ϵͳֽƵĺ
	 * @param card ϵͳҵĳֽ
	 */
	public void setXOfComputerCards(Card card) {
		card.setX(xCoordinateOfComputerCard);
		xCoordinateOfComputerCard += offsetBetweenCards;
	}

	/**
	 * ϵͳֽƵ
	 * @param card ϵͳҵĳֽ
	 */
	public void setYOfComputerCards(Card card) {
		card.setY(yCoordinateOfComputerCard);
	}

	/**
	 * ûֽƵĺ
	 * @param card ϵĳֽ
	 */
	public void setXOfTrainCard(Card card) {
		card.setX(xCoordinateOfTrainCard);	
		xCoordinateOfTrainCard += offsetBetweenCards;
	}

	/**
	 * ûֽƵ
	 * @param card ϵĳֽ
	 */
	public void setYOfTrainCard(Card card) {
		card.setY(yCoordinateOfTrainCard);
	}

	/**
	 * 㷨
	 * @param player ָ
	 * @param card Ҫҵֽ
	 */
	public void deal(int player, Card card) {
		getPlayerCards(player).add(card);	//ֽӵֽб
		card.setFace(true);		//ֽ泯
	}

	/**
	 * ĳҿʼϷ
	 * @param player 
	 */
	public void play(int player) {
		List<Card> playerCards = getPlayerCards(player);

		Card card = playerCards.remove(0);	//ƣ涨ҵĵһֽ
		train.add(card);	//ֽӵ
		setXOfTrainCard(card);	//øֽƵĺ
		setYOfTrainCard(card);	//øֽƵ

		resetXOfPlayerCard(player);		//ֽƵĺ
		/*  */
		for(int i = 0; i < train.size(); i ++) {
			if(getTrainCard(i).isSelected()) {//ĳƱѡ
				getTrainCard(i).setSelected(false);		//ȡѡ
				oneCardSelected = false;	//ûֽƱѡ

				/* Ʊѡͬ */
				if(getTrainCard(i).getPoint() == card.getPoint()) {
					reap(player, getTrainCard(i), i);
				}
				break;
			}
		}

		/* ݸҵǷΪ0жӮ */
		if(getPlayerCards(player).size() == 0) {
			if(player == PLAYER_COMPUTER) {//ϵͳ
				JOptionPane.showMessageDialog(null, "ϲ㣬Ӯ");

				removeMouseListener(mc);
				playTimer.cancel();
				meCountDown.cancel();
			} else if(player == PLAYER_ME) {//Լ
				JOptionPane.showMessageDialog(null, "");

				removeMouseListener(mc);
				playTimer.cancel();
				meCountDown.cancel();
			}
		}

	}

	/**
	 * ĳҵֽƺ
	 * @param player
	 */
	public void resetXOfPlayerCard(int player) {
		List<Card> resetCards = getPlayerCards(player);

		if(player == PLAYER_ME) {//Լ
			xCoordinateOfMyCard = 100;

			for(int i = 0; i < resetCards.size(); i ++) {//ԼֽƵĺ
				setXOfMyCards(resetCards.get(i));	
			}

		} else if(player == PLAYER_COMPUTER) {//ϵͳ
			xCoordinateOfComputerCard = 100;

			for(int i = 0; i < resetCards.size(); i ++) {//ϵͳֽƵĺ
				setXOfComputerCards(resetCards.get(i));	
			}
		}
	}

	/**
	 * ȡĳҵֽ
	 * @param player Ҫȡ
	 * @return ҵֽ
	 */
	public List<Card> getPlayerCards(int player) {
		return players.get(player);
	}

	/**
	 * 㷨
	 * @param player 
	 * @param card ҳ
	 * @param i ϿʼƵλõ±
	 */
	public void reap(int player, Card card, int i) {
		List<Card> subList = train.subList(i, train.size());	//ȡŵͬмֽ

		/* ֽƵĺ */
		for(int j = 0; j < subList.size(); j ++) {
			xCoordinateOfTrainCard -= offsetBetweenCards;
		}

		oneCardSelected = false;	//ûֽƱѡ
		addToPlayer(player, subList);	//ֽӵ
		subList.clear();	//ڻ𳵼аյֽƳ
	}

	/**
	 * ջصֽӵ
	 * @param player 
	 * @param cards ջصֽƵļ
	 */
	public void addToPlayer(int player, List<Card> cards) {
		getPlayerCards(player).addAll(cards);	//ӵ

		if(player == PLAYER_ME) {//Լ

			for(int i = 0; i < cards.size(); i ++) {//ӵԼϵֽƵĺ
				setXOfMyCards(cards.get(i));
				setYOfMyCards(cards.get(i));
			}

		} else if(player == PLAYER_COMPUTER) {//ϵͳ

			for(int i = 0; i < cards.size(); i ++) {//ӵԼϵֽƵĺ
				setXOfComputerCards(cards.get(i));
				setYOfComputerCards(cards.get(i));
			}

		}
	}

	@Override
	public void paint(Graphics g) {
		g.setColor(Color.BLACK);
		g.fillRect(0, 0, getBounds().width, getBounds().height);

		/* ֽ */
		for(int i = 0; i < cards.size(); i++) {
			cards.get(i).paintCard(g);			
		}

		/* Լֽ */
		for(int i = 0; i < getPlayerCards(PLAYER_ME).size(); i ++) {
			getPlayerCards(PLAYER_ME).get(i).paintCard(g);
		}

		/* ϵͳҵֽ */
		for(int i = 0; i < getPlayerCards(PLAYER_COMPUTER).size(); i ++) {
			getPlayerCards(PLAYER_COMPUTER).get(i).paintCard(g);
		}

		/* ƻ */
		for(int i = 0; i < train.size(); i ++) {
			getTrainCard(i).paintCard(g);
		}

		/* ʾʱ */
		g.setColor(Color.BLUE);
		g.setFont(new Font("Serif",Font.BOLD|Font.ITALIC,24));
		g.drawString(timeLeftForPlayerMe + "", 400, 400);
	}	
}
