package worm;

import java.awt.*;
import java.util.Arrays;

/**
 * ̰
 * @author Leslie Leung
 * @see Cell
 */
public class Worm {
	
	public static final int UP = 1;	//
	public static final int DOWN = -1;		//
	public static final int LEFT = 2;	//
	public static final int RIGHT = -2;	//
	public static final int DEFAULT_LENGTH = 6;	//̰ߵĬϳΪ6
	public static final int DEFAULT_DIRECTION = RIGHT;	//Ĭз
	public static final int INIT_SPEED = 100;	//̰߳ʼٶ
	
	private int currentLength;		//̰ߵǰ
	private int currentDirection;	//̰ߵǰ
	private boolean eat;	//ж̰ǷԵʳ
	private Cell[] cells;
	
	/**
	 * 췽ʼ̰
	 */
	public Worm() {
		cells = new Cell[DEFAULT_LENGTH];
		currentDirection = DEFAULT_DIRECTION;	//ϷһʼʱĬϷΪDOWN
		currentLength = DEFAULT_LENGTH;		//ʼǰ̰߳ΪĬϳ
		
		for(int i = 0;i < DEFAULT_LENGTH; i ++) {
			cells[i] = new Cell(DEFAULT_LENGTH - i - 1, 0);
		}

	}
	
	/**
	 * ȡ̰ߵǰ
	 * @return ̰ߵĵǰ
	 */
	public int getCurrentLength() {
		return currentLength;
	}
	
	/**
	 * ȡ̰ߵĵǰ
	 * @return ̰ߵĵǰ
	 */
	public int getCurrentDirection() {
		return currentDirection;
	}
	
	/**
	 * ̰Ƿһλص
	 * @param x Ľĺ
	 * @param y Ľ
	 * @return صtrueصfalse
	 */
	public boolean contains(int x, int y) {
		
		for(int i = 0; i < currentLength; i ++) {
			if(x == cells[i].getX() && y == cells[i].getY()) {
				return true;
			}
		}
			
		return false;
	}
	
	/**
	 * ı䷽
	 * @param ̰µз
	 */
	public void changeDirection(int direction) {
		/* ·뵱ǰ̰зͬ෴أȡκβ   */
		if(currentDirection == direction || currentDirection + direction == 0) {
			return;
		}
		
		currentDirection = direction;
	}
	
	/**
	 * 㷨Ƴĩβ㣬нƣٰĩβӵͷλ
	 * @param direction з
	 * @return ̰ǷԵʳtrueʾԵfalseʾԲ
	 */
	public boolean creep(int direction, Cell food) {
		eat = false;
		currentDirection = direction;	//зΪķ
		Cell head = newHead(currentDirection);	//ͷ
		
		/* ̰еһλϴʳݣ̰ߣʳ */
		if( head.getX() == food.getX() && head.getY() == food.getY() ) {
			cells = Arrays.copyOf(cells, cells.length + 1);
			eat = true;
			currentLength ++;	//Եʳ
		}
		
		for(int i = cells.length - 1; i > 0; i --) {
			cells[i] = cells[i - 1];
		}
		
		cells[0] = head;
		
		return eat;
	}
	
	/**
	 * ͷ㷨зͷ
	 * @param currentDirection ǰз
	 * @return ½ͷ
	 */
	public Cell newHead(int currentDirection) {
		Cell newHead = null;
		
		switch(currentDirection) {
			case UP: 
				newHead = new Cell(cells[0].getX(), cells[0].getY() - 1);
				break;
			case DOWN:
				newHead = new Cell(cells[0].getX(), cells[0].getY() + 1);
				break;
			case LEFT: 
				newHead = new Cell(cells[0].getX() - 1, cells[0].getY());
				break;
			case RIGHT:
				newHead = new Cell(cells[0].getX() + 1, cells[0].getY());
				break;
		}
		
		return newHead;
	}
	
	/**
	 * ̰Ƿײ㷨
	 * @param direction ǰ˶
	 * @return Ƿײ
	 */
	public boolean hit(int direction) {
		Cell nextHead = newHead(direction);
		
		/* Ƿײ */
		if( this.contains(nextHead.getX(), nextHead.getY()) ) {
			return true;
		}
		
		/* ̰Ƿ */
		if(nextHead.getX() < 0 || nextHead.getX() >= WormStage.COLUMNS
				||nextHead.getY() < 0 || nextHead.getY() >= WormStage.ROWS) {
			return true;
		}
		
		return false;
	}
	
	/* ̰ */
	public void paint(Graphics g) {
		for(int i = 0; i < cells.length; i ++) {
			cells[i].paintCell(g);
		}
	}
}
